/*
 * Projecte Fressa a JAVA
 * EntradaDeSo.java
 * Created on 26 / desembre / 2008, 11:10
 *
 * @author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 * amb el suport del Departament d'Educacio de la Generalitat de Catalunya
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 */

import javax.sound.sampled.*;
import java.awt.*;
import java.awt.event.*;

public class EntradaDeSo {
    
  AudioFormat audioFormat;
  TargetDataLine targetDataLine;
  AudioInputStream audioInputStream;
  SourceDataLine sourceDataLine;

  public boolean stopCapture = false;
  public int TamanyBuffer=512;
  public int channels = 1; //1,2
  public byte tempBuffer[] = new byte[TamanyBuffer*2];
  public int MimimSo = 32;
  public boolean SHaPassatElMinim=false;

  public EntradaDeSo() {
    IniciarDades();
  }
    
  public void IniciarDades() {
    int i=0;
    while (i<TamanyBuffer*2) {
      tempBuffer[i]=0;
      i=i+1;
    }
    SHaPassatElMinim=false;
  }
    
  public void captureAudio(int c){
    try{
      channels=c;  
      audioFormat = getAudioFormat();
      DataLine.Info dataLineInfo =new DataLine.Info(TargetDataLine.class,audioFormat);
      targetDataLine = (TargetDataLine)AudioSystem.getLine(dataLineInfo);
      targetDataLine.open(audioFormat,TamanyBuffer*channels);      
      targetDataLine.start();
      Thread captureThread =new Thread(new CaptureThread());
      captureThread.start();
    } catch (Exception e) {
      System.out.println(e);
      System.exit(0);
    }
  }

  private AudioFormat getAudioFormat(){
    float sampleRate = 11025.0F; //8000,11025,16000,22050,44100
    int sampleSizeInBits = 8; //8,16
    //int channels = 1; //1,2
    //int channels = channels;
    boolean signed = true; //true,false
    boolean bigEndian = false; //true,false
    return new AudioFormat(sampleRate,sampleSizeInBits,channels,signed,bigEndian);
  }

  class CaptureThread extends Thread{
    byte maximL, maximR;
    int i;
  
    public void run(){
      stopCapture = false;
      try{
        while(!stopCapture){
          maximL=0;
          maximR=0;
          //int cnt = targetDataLine.read(tempBuffer,0,tempBuffer.length);
          int cnt = targetDataLine.read(tempBuffer,0,TamanyBuffer*channels);
          if(cnt > 0){
            if (channels==1) {
              i=1;
              while (i<TamanyBuffer) {
                if (tempBuffer[i]>maximL) {
                  maximL=tempBuffer[i];
                }
                i=i+1;
              }
              if (maximL>MimimSo) {
                if (SHaPassatElMinim==false) {
                  try {
                    Robot r = new Robot();
                    r.mousePress(InputEvent.BUTTON1_MASK);
                    r.mouseRelease(InputEvent.BUTTON1_MASK);
                  } catch (AWTException e) {
                    e.printStackTrace();
                  }
                }
                SHaPassatElMinim=true;
              } else {
                SHaPassatElMinim=false;  
              } 
            } else {        
              i=1;
              while (i<TamanyBuffer*channels-1) {
                if (tempBuffer[i]>maximL) {
                  maximL=tempBuffer[i];
                }
                i=i+2;
              }
              i=2;
              while (i<TamanyBuffer*channels-1) {
                if (tempBuffer[i]>maximR) {
                  maximR=tempBuffer[i];
                }
                i=i+2;
              }
              if ((maximL>MimimSo) || (maximR>MimimSo)) {
                if (SHaPassatElMinim==false) {
                  if (maximL>MimimSo)  {  
                    try {
                      Robot r = new Robot();
                      r.mousePress(InputEvent.BUTTON1_MASK);
                      r.mouseRelease(InputEvent.BUTTON1_MASK);
                    } catch (AWTException e) {
                      e.printStackTrace();
                    }                    
                  } else if (maximR>MimimSo) {
                    Llengua.plaphoons.CanviLlocEscaneig();                    
                  }
                }  
                SHaPassatElMinim=true;
              } else {
                SHaPassatElMinim=false;                    
              }
            }
            String s=String.valueOf(maximL)+" | "+String.valueOf(maximR);
            //Llengua.plaphoons.setTitle(s);
          }
        }
      }catch (Exception e) {
        System.out.println(e);
        //System.exit(0);
      }
    }
  }

}
