/*
 * Projecte Fressa a JAVA
 * FilterObrirFitxerRecurs.java
 *
 * @author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 * amb el suport del Departament d'Educacio de la Generalitat de Catalunya
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 */

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/* Per filtrar els fitxers recursos en el TFormEdicioPlafo Obrir pel JFileChooser fc */
public class FilterObrirFitxerRecurs extends FileFilter {

    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        String extension = getExtension(f);
        if (extension != null) {
            if (extension.equals("jpg")) {
              return true;
            } else if (extension.equals("gif")) {
              return true;
            } else if (extension.equals("png")) {
              return true;
            } else if (extension.equals("wav")) {
              return true;
            } else if (extension.equals("bmp")) {
              return true;
            } else {
              return false;
            }
        }
        return false;
    }

    public String getDescription() {
        return "Recursos Java Plaphoons *.jpg,*.gif,*.png,*.bmp,*.wav";
    }

    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }

}

