library JavaPlaphoonsWindowsLibrary;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  View-Project Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the DELPHIMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using DELPHIMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  Dialogs,
  Windows,
  Messages,
  JNI in 'JNI.pas',
  UnitFindAWindow in 'UnitFindAWindow.pas';

{****************************************************}
procedure Java_JavaPlaphoonsWindowsLibrary_DisplayHelloWorld(PEnv: PJNIEnv; Obj: JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  ShowMessage('Hello world!');
end;

procedure Java_edu_xtec_fressa_JavaPlaphoonsWindowsLibrary_DisplayHelloWorld(PEnv: PJNIEnv; Obj: JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  ShowMessage('Hello world!');
end;

{****************************************************}
{WINDOWS                                             }
{****************************************************}
function Java_JavaPlaphoonsWindowsLibrary_GetForegroundWindow(PEnv: PJNIEnv; Obj: JObject):JInt; {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  Java_JavaPlaphoonsWindowsLibrary_GetForegroundWindow:=GetForegroundWindow;
end;

procedure Java_JavaPlaphoonsWindowsLibrary_SetForegroundWindow(PEnv: PJNIEnv; Obj: JObject; H:HWnd); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
{
var
 r:bool;
}
begin
  {
  ShowMessage('BringWindowToTop '+IntToStr(H));
  try
    r:=BringWindowToTop(H);
    if r then ShowMessage('true') else ShowMessage('false');
  except
    ShowMessage('El BringWindowToTop ha fallat');
  end;
  }
  SetForegroundWindow(H);
  //BringWindowToTop(H);
end;

procedure Java_JavaPlaphoonsWindowsLibrary_MoveResizeWindow(PEnv: PJNIEnv; Obj: JObject; H: HWnd; x,y,width,height:JInt); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  SetWindowPos(H,HWND_TOP,x,y,width,height,0);
  SetWindowPos(H,HWND_TOP,x,y,width,height,SWP_SHOWWINDOW);
end;

function Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesX(PEnv: PJNIEnv; Obj: JObject; H: HWnd):JInt; {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  MyRect:TRect;
begin
  GetWindowRect(H, MyRect);
  Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesX:=MyRect.Left;
end;

function Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesY(PEnv: PJNIEnv; Obj: JObject; H: HWnd):JInt; {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  MyRect:TRect;
begin
  GetWindowRect(H, MyRect);
  Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesY:=MyRect.Top;
end;

function Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesWidth(PEnv: PJNIEnv; Obj: JObject; H: HWnd):JInt; {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  MyRect:TRect;
begin
  GetWindowRect(H, MyRect);
  Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesWidth:=MyRect.Right-MyRect.Left;
end;

function Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesHeight(PEnv: PJNIEnv; Obj: JObject; H: HWnd):JInt; {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  MyRect:TRect;
begin
  GetWindowRect(H, MyRect);
  Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesHeight:=MyRect.Bottom -MyRect.Top;
end;

function Java_JavaPlaphoonsWindowsLibrary_GetWindowText(PEnv: PJNIEnv; Obj: JObject; H: HWnd):JString; {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  s:array[0..255] of char;
  JVM: TJNIEnv;
begin
  GetWindowText(H,s,255);
  //ShowMessage(StrPas(s));
  JVM := TJNIEnv.Create(PEnv);
  Java_JavaPlaphoonsWindowsLibrary_GetWindowText:=JVM.StringToJString(s);
  JVM.Free;
end;

//procedure Java_JavaPlaphoonsWindowsLibrary_GetWindowText(PEnv: PJNIEnv; Obj: JObject; H: HWnd); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
{
var
  s:array[0..255] of char;
begin
  GetWindowText(H,s,255);
  ShowMessage(StrPas(s));
end;
}

{****************************************************}
{UPCTV                                               }
{****************************************************}
type
  TupcTVAbout = function:integer;stdcall;
  TupcTVRead = function(P:PChar):integer;stdcall;
  TupcTVReadFile = function(P:PChar):integer;stdcall;
  TupcTVStop = function:integer;stdcall;
  TupcTVPause = function:integer;stdcall;
  TupcTVResume = function:integer;stdcall;
  TupcTVSetLanguage = function(s:integer):integer;stdcall;
  TupcTVSetSpeed = function(v:byte):integer;stdcall;
  TupcTVSetSpeaker = function(v:byte):integer;stdcall;
  TupcTVStatus = function(timeOut:longint):integer;stdcall;

var
  HModuleUPCTV:THandle;
  upcTVAbout:TupcTVAbout;
  upcTVRead:TupcTVRead;
  upcTVReadFile:TupcTVReadFile;
  upcTVStop:TupcTVStop;
  upcTVPause:TupcTVPause;
  upcTVResume:TupcTVResume;
  upcTVSetLanguage:TupcTVSetLanguage;
  upcTVSetSpeed:TupcTVSetSpeed;
  upcTVSetSpeaker:TupcTVSetSpeaker;
  upcTVStatus:TupcTVStatus;
  upcTVCatala:boolean;
  upcTVHome:boolean;

procedure RecarregarLlibreria;
begin
  if HModuleUPCTV>31 then begin
    upcTVAbout:=nil;
    upcTVRead:=nil;
    upcTVReadFile:=nil;
    upcTVStop:=nil;
    upcTVPause:=nil;
    upcTVResume:=nil;
    upcTVSetLanguage:=nil;
    upcTVSetSpeed:=nil;
    upcTVSetSpeaker:=nil;
    upcTVStatus:=nil;
    FreeLibrary(HModuleUPCTV);
  end else exit;
  HModuleUPCTV:=LoadLibrary('UPCTV.DLL');
  if HModuleUPCTV>31 then begin
    @upcTVAbout:=GetProcAddress(HModuleUPCTV,'upcTVAbout');
    @upcTVRead:=GetProcAddress(HModuleUPCTV,'upcTVRead');
    @upcTVReadFile:=GetProcAddress(HModuleUPCTV,'upcTVReadFile');
    @upcTVStop:=GetProcAddress(HModuleUPCTV,'upcTVStop');
    @upcTVPause:=GetProcAddress(HModuleUPCTV,'upcTVPause');
    @upcTVResume:=GetProcAddress(HModuleUPCTV,'upcTVResume');
    @upcTVSetLanguage:=GetProcAddress(HModuleUPCTV,'upcTVSetLanguage');
    @upcTVSetSpeed:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeed');
    @upcTVSetSpeaker:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeaker');
    @upcTVStatus:=GetProcAddress(HModuleUPCTV,'upcTVStatus');
    upcTVSetSpeed(100);
  end;
end;

procedure Java_JavaPlaphoonsWindowsLibrary_UPCTVRead(PEnv:PJNIEnv; Obj:JObject; Value:Jstring); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  Str: string;
  JVM: TJNIEnv;
begin
  if not (HModuleUPCTV>31) then exit;
  upcTVStop;
  JVM:=TJNIEnv.Create(PEnv);
  //Str:=JVM.JStringToString(Value);
  Str:=JVM.UnicodeJStringToString(Value);;
  Str:=LowerCase(Str);
  upcTVRead(PChar(Str+' '));
end;

procedure Java_JavaPlaphoonsWindowsLibrary_UPCTVStop(PEnv: PJNIEnv; Obj: JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  upcTVStop;
end;

function Java_JavaPlaphoonsWindowsLibrary_UPCTVStatus(PEnv: PJNIEnv; Obj: JObject):JBoolean; {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  if upcTVStatus(0)=0 then Java_JavaPlaphoonsWindowsLibrary_UPCTVStatus:=false else Java_JavaPlaphoonsWindowsLibrary_UPCTVStatus:=true;
end;

procedure Java_JavaPlaphoonsWindowsLibrary_UPCTVHome(PEnv: PJNIEnv; Obj: JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  if not (HModuleUPCTV>31) then exit;
  upcTVHome:=true;
  upcTVStop;
  RecarregarLlibreria;
  if upcTVCatala then begin
    upcTVSetLanguage(99);
    upcTVSetSpeaker(0);
  end else begin
    upcTVSetLanguage(101);
    upcTVSetSpeaker(1);
  end;
end;

procedure Java_JavaPlaphoonsWindowsLibrary_UPCTVDona(PEnv: PJNIEnv; Obj: JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  if not (HModuleUPCTV>31) then exit;
  upcTVHome:=false;
  upcTVStop;
  RecarregarLlibreria;
  if upcTVCatala then begin
    upcTVSetLanguage(99);
    upcTVSetSpeaker(2);
  end else begin
    upcTVSetLanguage(101);
    upcTVSetSpeaker(0);
  end;
end;

procedure Java_JavaPlaphoonsWindowsLibrary_UPCTVCatala(PEnv: PJNIEnv; Obj: JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  if not (HModuleUPCTV>31) then exit;
  upcTVCatala:=true;
  upcTVStop;
  RecarregarLlibreria;
  if upcTVHome then begin
    upcTVSetLanguage(99);
    upcTVSetSpeaker(0);
  end else begin
    upcTVSetLanguage(99);
    upcTVSetSpeaker(2);
  end;
end;

procedure Java_JavaPlaphoonsWindowsLibrary_UPCTVCastella(PEnv: PJNIEnv; Obj: JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
begin
  if not (HModuleUPCTV>31) then exit;
  upcTVCatala:=false;
  upcTVStop;
  RecarregarLlibreria;
  if upcTVHome then begin
    upcTVSetLanguage(101);
    upcTVSetSpeaker(1);
  end else begin
    upcTVSetLanguage(101);
    upcTVSetSpeaker(0);
  end;
end;

{****************************************************}
{Llegir Java Fressa Windows Platform                 }
{****************************************************}
const
  wm_Llegir = wm_User;
  wm_CanviarSintetitzador = wm_User+1;

{****************************************************}
{PLAPHOONS                                           }
{****************************************************}
procedure Java_JavaPlaphoonsWindowsLibrary_LlegeixSeleccionarIdioma(PEnv:PJNIEnv; Obj:JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  AppInstLlegeix:HWnd;
begin
  AppInstLlegeix:=FindAWindow('Llegir Java Fressa Windows Platform - Projecte Fressa 2008 - www.lagares.org','');
  if AppInstLlegeix>0 then begin
    SendMessage(AppInstLlegeix,wm_CanviarSintetitzador,0,0);
    SetForegroundWindow(AppInstLlegeix);
    BringWindowToTop(AppInstLlegeix);
  end;
end;

//Fa servir el procedure TFormPrincipal.LecturaDeProgramaExternCopyData(var Msg: TWMCopyData); del LlegirJavaFressaWindowsPlatform
//procedure Java_JavaPlaphoonsWindowsLibrary_Llegeix(PEnv:PJNIEnv; Obj:JObject; Value:Jstring); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
{
var
  Str: string;
  JVM: TJNIEnv;
  AppInstLlegeix:HWnd;
begin
  JVM:=TJNIEnv.Create(PEnv);
  //Str:=JVM.JStringToString(Value);
  Str:=JVM.UnicodeJStringToString(Value);;
  //ShowMessage(Str);
  Str:=LowerCase(Str)+' ';
  AppInstLlegeix:=FindAWindow('Llegir Java Fressa Windows Platform - Projecte Fressa 2008 - www.lagares.org','');
  if AppInstLlegeix>0 then begin
    writePrivateProfileString('LLEGEIX','LLEGIR',PChar(Str),'LlegirJavaFressaWindowsPlatform.ini');
    SendMessage(AppInstLlegeix,wm_Llegir,0,0);
  end;
end;
}
//Fa servir el procedure TFormPrincipal.LecturaDeProgramaExternCopyData(var Msg: TWMCopyData); del LlegirJavaFressaWindowsPlatform
procedure Java_JavaPlaphoonsWindowsLibrary_Llegeix(PEnv:PJNIEnv; Obj:JObject; Value:Jstring); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  Str: string;
  JVM: TJNIEnv;
  AppInstLlegeix:HWnd;
  stringToSend: string;
  copyDataStruct: TCopyDataStruct;
begin
  JVM:=TJNIEnv.Create(PEnv);
  //Str:=JVM.JStringToString(Value);
  Str:=JVM.UnicodeJStringToString(Value);;
  //ShowMessage(Str);
  Str:=LowerCase(Str)+' ';
  stringToSend:=Str;
  copyDataStruct.dwData := 0; //use it to identify the message contents
  copyDataStruct.cbData := 1 + Length(stringToSend) ;
  copyDataStruct.lpData := PChar(stringToSend) ;
  AppInstLlegeix:=FindAWindow('Llegir Java Fressa Windows Platform - Projecte Fressa 2008 - www.lagares.org','');
  if AppInstLlegeix>0 then begin
    //SendMessage(AppInstLlegeix, WM_COPYDATA, Integer(Handle), Integer(@copyDataStruct)) ;
    SendMessage(AppInstLlegeix, WM_COPYDATA, Integer(nil), Integer(@copyDataStruct)) ;
  end;
end;

{****************************************************}
{JClicFressa                                         }
{****************************************************}
procedure Java_edu_xtec_fressa_JavaPlaphoonsWindowsLibrary_LlegeixSeleccionarIdioma(PEnv:PJNIEnv; Obj:JObject); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  AppInstLlegeix:HWnd;
begin
  AppInstLlegeix:=FindAWindow('Llegir Java Fressa Windows Platform - Projecte Fressa 2008 - www.lagares.org','');
  if AppInstLlegeix>0 then begin
    SendMessage(AppInstLlegeix,wm_CanviarSintetitzador,0,0);
    SetForegroundWindow(AppInstLlegeix);
    BringWindowToTop(AppInstLlegeix);
  end;
end;

//procedure Java_edu_xtec_fressa_JavaPlaphoonsWindowsLibrary_Llegeix(PEnv:PJNIEnv; Obj:JObject; Value:Jstring); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
{
var
  Str: string;
  JVM: TJNIEnv;
  AppInstLlegeix:HWnd;
begin
  JVM:=TJNIEnv.Create(PEnv);
  //Str:=JVM.JStringToString(Value);
  Str:=JVM.UnicodeJStringToString(Value);;
  //ShowMessage(Str);
  Str:=LowerCase(Str)+' ';
  AppInstLlegeix:=FindAWindow('Llegir Java Fressa Windows Platform - Projecte Fressa 2008 - www.lagares.org','');
  if AppInstLlegeix>0 then begin
    writePrivateProfileString('LLEGEIX','LLEGIR',PChar(Str),'LlegirJavaFressaWindowsPlatform.ini');
    SendMessage(AppInstLlegeix,wm_Llegir,0,0);
  end;
end;
}
procedure Java_edu_xtec_fressa_JavaPlaphoonsWindowsLibrary_Llegeix(PEnv:PJNIEnv; Obj:JObject; Value:Jstring); {$IFDEF MSWINDOWS} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  Str: string;
  JVM: TJNIEnv;
  AppInstLlegeix:HWnd;
  stringToSend: string;
  copyDataStruct: TCopyDataStruct;
begin
  JVM:=TJNIEnv.Create(PEnv);
  //Str:=JVM.JStringToString(Value);
  Str:=JVM.UnicodeJStringToString(Value);;
  //ShowMessage(Str);
  Str:=LowerCase(Str)+' ';
  stringToSend:=Str;
  copyDataStruct.dwData := 0; //use it to identify the message contents
  copyDataStruct.cbData := 1 + Length(stringToSend) ;
  copyDataStruct.lpData := PChar(stringToSend) ;
  AppInstLlegeix:=FindAWindow('Llegir Java Fressa Windows Platform - Projecte Fressa 2008 - www.lagares.org','');
  if AppInstLlegeix>0 then begin
    //SendMessage(AppInstLlegeix, WM_COPYDATA, Integer(Handle), Integer(@copyDataStruct)) ;
    SendMessage(AppInstLlegeix, WM_COPYDATA, Integer(nil), Integer(@copyDataStruct)) ;
  end;
end;

{****************************************************}
exports
  Java_JavaPlaphoonsWindowsLibrary_DisplayHelloWorld,
  Java_edu_xtec_fressa_JavaPlaphoonsWindowsLibrary_DisplayHelloWorld,

{WINDOWS                                             }
  Java_JavaPlaphoonsWindowsLibrary_GetForegroundWindow,
  Java_JavaPlaphoonsWindowsLibrary_SetForegroundWindow,
  Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesX,
  Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesY,
  Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesWidth,
  Java_JavaPlaphoonsWindowsLibrary_GetWindowAttributesHeight,
  Java_JavaPlaphoonsWindowsLibrary_MoveResizeWindow,
  Java_JavaPlaphoonsWindowsLibrary_GetWindowText,

{Llegir Java Fressa Windows Platform                 }
   //Plaphoons
   Java_JavaPlaphoonsWindowsLibrary_LlegeixSeleccionarIdioma,
  Java_JavaPlaphoonsWindowsLibrary_Llegeix,
  //JCliFressa
  Java_edu_xtec_fressa_JavaPlaphoonsWindowsLibrary_LlegeixSeleccionarIdioma,
  Java_edu_xtec_fressa_JavaPlaphoonsWindowsLibrary_Llegeix,

{UPCTV                                               }
  Java_JavaPlaphoonsWindowsLibrary_UPCTVRead,
  Java_JavaPlaphoonsWindowsLibrary_UPCTVStop,
  Java_JavaPlaphoonsWindowsLibrary_UPCTVStatus,
  Java_JavaPlaphoonsWindowsLibrary_UPCTVHome,
  Java_JavaPlaphoonsWindowsLibrary_UPCTVDona,
  Java_JavaPlaphoonsWindowsLibrary_UPCTVCatala,
  Java_JavaPlaphoonsWindowsLibrary_UPCTVCastella;

begin
  HModuleUPCTV:=LoadLibrary('upctv.dll');
  if HModuleUPCTV>31 then begin
    //@upcTVSetSpeed:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeed');
    @upcTVAbout:=GetProcAddress(HModuleUPCTV,'upcTVAbout');
    @upcTVRead:=GetProcAddress(HModuleUPCTV,'upcTVRead');
    @upcTVReadFile:=GetProcAddress(HModuleUPCTV,'upcTVReadFile');
    @upcTVStop:=GetProcAddress(HModuleUPCTV,'upcTVStop');
    @upcTVPause:=GetProcAddress(HModuleUPCTV,'upcTVPause');
    @upcTVResume:=GetProcAddress(HModuleUPCTV,'upcTVResume');
    @upcTVSetLanguage:=GetProcAddress(HModuleUPCTV,'upcTVSetLanguage');
    @upcTVSetSpeed:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeed');
    @upcTVSetSpeaker:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeaker');
    @upcTVStatus:=GetProcAddress(HModuleUPCTV,'upcTVStatus');
    upcTVSetSpeed(100);
  end;
  upcTVCatala:=true;
  upcTVHome:=true;
  try
    winexec('LlegirJavaFressaWindowsPlatform.exe',SW_SHOWNORMAL);
  except
  end;
end.
