unit UnitFormEscollirSintetitzador;

{****************************************************}
interface
{****************************************************}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, OleServer, SpeechLib_TLB, Speech;

type
  TFormEscollirSintetitzador = class(TForm)
    ComboBoxSintetitzadors: TComboBox;
    BitBtnCancelar: TBitBtn;
    BitBtnDAcord: TBitBtn;
    SpVoice: TSpVoice;
    procedure BitBtnDAcordClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpVoiceEndStream(Sender: TObject; StreamNumber: Integer;StreamPosition: OleVariant);
  private
    { Private declarations }
    AMMD:IAudioMultiMediaDevice;
    TTSEnum:ITTSEnum;
    PModeInfo:PTTSModeInfo;
    TTSCentral:ITTSCentral;
    BufferSink:ITTSBufNotifySink;
  public
    { Public declarations }
    StatusSapi5:integer;
    Procedure SpeakSAPI5(s:string);
    Procedure PararSAPI5;
    Procedure SpeakSAPI4(s:string);
    Procedure PararSAPI4;
    Procedure CanviarElSintetitzador(Item:string);
  end;

var
  FormEscollirSintetitzador: TFormEscollirSintetitzador;
  StringSintetitzador:String;
  QuinSintetitzador:String;

{****************************************************}
implementation
{****************************************************}

uses ComObj, MMSystem, UnitUPCTV, UnitLlegir;

{$R *.DFM}

procedure TFormEscollirSintetitzador.FormCreate(Sender: TObject);
var
  i:Integer;
  ModeInfo:TTTSModeInfo;
  PModeInfo:PTTSModeInfo;
  NumFound:DWord;
  SOToken:ISpeechObjectToken;
  SOTokens:ISpeechObjectTokens;
begin
  QuinSintetitzador:='';
  //UPCTV
  if IniciarUPCTV=1 then begin
    QuinSintetitzador:='UPCTV';
    ComboBoxSintetitzadors.Items.Append('UPCTV - Catal - Home');
    ComboBoxSintetitzadors.Items.Append('UPCTV - Catal - Dona');
    ComboBoxSintetitzadors.Items.Append('UPCTV - Castellano - Hombre');
    ComboBoxSintetitzadors.Items.Append('UPCTV - Castellano - Mujer');
    ComboBoxSintetitzadors.ItemIndex:=0;
    StringSintetitzador:='UPCTV - Catal - Home';
  end;
  //SAPI 4
  try
    AMMD:=CreateComObject(CLSID_MMAudioDest) as IAudioMultiMediaDevice;
    OleCheck(AMMD.DeviceNumSet(WAVE_MAPPER));
    //Aquest s el pas que triga tant
    TTSEnum:=CreateComObject(CLSID_TTSEnumerator) as ITTSEnum;
    OleCheck(TTSEnum.Reset);
    OleCheck(TTSEnum.Next(1, ModeInfo, @NumFound));
    While NumFound > 0 do begin
      New(PModeInfo);
      PModeInfo^ := ModeInfo;
      ComboBoxSintetitzadors.Items.AddObject('SAPI 4 - '+String(ModeInfo.szModeName), TObject(PModeInfo));
      OleCheck(TTSEnum.Next(1, ModeInfo, @NumFound));
    end;
    for i:=0 to ComboBoxSintetitzadors.Items.Count-1 do begin
      if ComboBoxSintetitzadors.Items[i]='SAPI 4 - AO010' then ComboBoxSintetitzadors.Items[i]:='SAPI 4 - VERBIO Femenino-Espaol';
      if ComboBoxSintetitzadors.Items[i]='SAPI 4 - CD010' then ComboBoxSintetitzadors.Items[i]:='SAPI 4 - VERBIO Home-Catal';
      if ComboBoxSintetitzadors.Items[i]='SAPI 4 - EB010' then ComboBoxSintetitzadors.Items[i]:='SAPI 4 - VERBIO Masculino-Espaol';
      if ComboBoxSintetitzadors.Items[i]='SAPI 4 - FE010' then ComboBoxSintetitzadors.Items[i]:='SAPI 4 - VERBIO Dona-Catal';
    end;
  except
  end;
  //SAPI 5
  SpVoice.EventInterests:=SVEAllEvents;
  SOTokens:=SpVoice.GetVoices('','');
  StatusSapi5:=0;
  for i:=0 to SOTokens.Count - 1 do begin
    SOToken:=SOTokens.Item(i);
    ComboBoxSintetitzadors.Items.AddObject('SAPI 5 - '+SOToken.GetDescription(0), TObject(SOToken));
    SOToken._AddRef;
  end;
end;

Procedure TFormEscollirSintetitzador.CanviarElSintetitzador(Item:string);
var
  SOToken: ISpeechObjectToken;
begin
  if StringSintetitzador<>item then begin
    if item='UPCTV - Catal - Home' then begin
      QuinSintetitzador:='UPCTV';
      StringSintetitzador:='UPCTV - Catal - Home';
      CatalaHomeUPCTV;
    end else if item='UPCTV - Catal - Dona' then begin
      QuinSintetitzador:='UPCTV';
      StringSintetitzador:='UPCTV - Catal - Dona';
      CatalaDonaUPCTV;
    end else if item='UPCTV - Castellano - Hombre' then begin
      QuinSintetitzador:='UPCTV';
      StringSintetitzador:='UPCTV - Castellano - Hombre';
      CastellaHomeUPCTV;
    end else if item='UPCTV - Castellano - Mujer' then begin
      QuinSintetitzador:='UPCTV';
      StringSintetitzador:='UPCTV - Castellano - Mujer';
      CastellaDonaUPCTV;
    end else if Copy(item,1,6)='SAPI 4' then begin
      if QuinSintetitzador='SAPI 4' then begin
        //OleCheck(TTSCentral.UnRegister(EngineSinkCookie));
        TTSCentral := nil;
      end;
      QuinSintetitzador:='SAPI 4';
      PModeInfo := PTTSModeInfo(ComboBoxSintetitzadors.Items.Objects[ComboBoxSintetitzadors.ItemIndex]);
      OleCheck(TTSEnum.Select(PModeInfo.gModeID, TTSCentral, AMMD));
      //OleCheck(TTSCentral.Register(Pointer(TTSNotifySink),ITTSNotifySink, EngineSinkCookie));
    end else if Copy(item,1,6)='SAPI 5' then begin
      QuinSintetitzador:='SAPI 5';
      SOToken:=ISpeechObjectToken(Pointer(ComboBoxSintetitzadors.Items.Objects[ComboBoxSintetitzadors.ItemIndex]));
      SpVoice.Voice:=SOToken;
    end;
  end;
  StringSintetitzador:=ComboBoxSintetitzadors.Items[ComboBoxSintetitzadors.ItemIndex];
  WritePrivateProfileString('SINTETITZADOR','Sintetitzador',PChar(StringSintetitzador),'LlegirJavaFressaWindowsPlatform.ini');
end;

procedure TFormEscollirSintetitzador.BitBtnDAcordClick(Sender: TObject);
var
  item:string;
begin
  item:=ComboBoxSintetitzadors.Items[ComboBoxSintetitzadors.ItemIndex];
  CanviarElSintetitzador(Item);
end;

{****************************************************}
Procedure TFormEscollirSintetitzador.SpeakSAPI5(s:string);
begin
  SpVoice.Speak(S,SVSFlagsAsync);
  StatusSapi5:=1;
end;

Procedure TFormEscollirSintetitzador.PararSAPI5;
begin
  SpVoice.Skip('Sentence', MaxInt);
  StatusSapi5:=0;
end;

procedure TFormEscollirSintetitzador.SpVoiceEndStream(Sender: TObject; StreamNumber: Integer;StreamPosition: OleVariant);
begin
  StatusSapi5:=0;
end;

{****************************************************}
Procedure TFormEscollirSintetitzador.SpeakSAPI4(s:string);
var
  SData: TSData;
begin
  SData.dwSize := Succ(Length(s));
  SData.pData := PChar(S);
  OleCheck(TTSCentral.TextData(CHARSET_TEXT, 0, SData,Pointer(BufferSink), ITTSBufNotifySink));
end;

Procedure TFormEscollirSintetitzador.PararSAPI4;
begin
  OleCheck(TTSCentral.AudioReset);
end;

end.
