unit UnitUPCTV;

{**********************************************************************}
interface
{**********************************************************************}

uses Windows;

type
  TupcTVAbout = function:integer;stdcall;
  TupcTVRead = function(P:PChar):integer;stdcall;
  TupcTVReadFile = function(P:PChar):integer;stdcall;
  TupcTVStop = function:integer;stdcall;
  TupcTVPause = function:integer;stdcall;
  TupcTVResume = function:integer;stdcall;
  TupcTVSetLanguage = function(s:integer):integer;stdcall;
  TupcTVSetSpeed = function(v:byte):integer;stdcall;
  TupcTVSetSpeaker = function(v:byte):integer;stdcall;
  TupcTVStatus = function(timeOut:longint):integer;stdcall;

var
  HModuleUPCTV:THandle;
  upcTVAbout:TupcTVAbout;
  upcTVRead:TupcTVRead;
  upcTVReadFile:TupcTVReadFile;
  upcTVStop:TupcTVStop;
  upcTVPause:TupcTVPause;
  upcTVResume:TupcTVResume;
  upcTVSetLanguage:TupcTVSetLanguage;
  upcTVSetSpeed:TupcTVSetSpeed;
  upcTVSetSpeaker:TupcTVSetSpeaker;
  upcTVStatus:TupcTVStatus;

var
  upcTVVelocitat:integer;
  upcTVHome:boolean;
  upcTVCatala:boolean;

Function IniciarUPCTV:Integer;
Procedure CatalaUPCTV;
Procedure CastellaUPCTV;
Procedure HomeUPCTV;
Procedure DonaUPCTV;
Procedure CanviarVelocitatUPCTV(i:integer);

Procedure CatalaHomeUPCTV;
Procedure CatalaDonaUPCTV;
Procedure CastellaHomeUPCTV;
Procedure CastellaDonaUPCTV;

{**********************************************************************}
implementation
{**********************************************************************}

Function IniciarUPCTV:integer;
begin
  HModuleUPCTV:=LoadLibrary('UPCTV.DLL');
  if HModuleUPCTV>31 then begin
    @upcTVSetSpeed:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeed');
    @upcTVAbout:=GetProcAddress(HModuleUPCTV,'upcTVAbout');
    @upcTVRead:=GetProcAddress(HModuleUPCTV,'upcTVRead');
    @upcTVReadFile:=GetProcAddress(HModuleUPCTV,'upcTVReadFile');
    @upcTVStop:=GetProcAddress(HModuleUPCTV,'upcTVStop');
    @upcTVPause:=GetProcAddress(HModuleUPCTV,'upcTVPause');
    @upcTVResume:=GetProcAddress(HModuleUPCTV,'upcTVResume');
    @upcTVSetLanguage:=GetProcAddress(HModuleUPCTV,'upcTVSetLanguage');
    @upcTVSetSpeed:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeed');
    @upcTVSetSpeaker:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeaker');
    @upcTVStatus:=GetProcAddress(HModuleUPCTV,'upcTVStatus');
    upcTVSetSpeed(100);
    IniciarUPCTV:=1;
  end else begin
    //MessageBox(Application.Handle,'No trobo la upctv.dll. Instal.leu-la correctament. Si teniu Sintetitzadors MS Agent els puc fer servir.','Fressa 2003 - Lectura de textos',mb_IconInformation+mb_Ok);
    IniciarUPCTV:=0;
  end;
end;

Function RecarregarLlibreriaUPCTV:integer;
var
  i:integer;
begin
  RecarregarLlibreriaUPCTV:=0;
  if HModuleUPCTV>31 then begin
    if upcTVStatus(0)<>0 then upcTVStop;
    upcTVAbout:=nil;
    upcTVRead:=nil;
    upcTVReadFile:=nil;
    upcTVStop:=nil;
    upcTVPause:=nil;
    upcTVResume:=nil;
    upcTVSetLanguage:=nil;
    upcTVSetSpeed:=nil;
    upcTVSetSpeaker:=nil;
    upcTVStatus:=nil;
    FreeLibrary(HModuleUPCTV);
  end else exit;
  HModuleUPCTV:=LoadLibrary('UPCTV.DLL');
  if HModuleUPCTV>31 then begin
    RecarregarLlibreriaUPCTV:=1;
    @upcTVAbout:=GetProcAddress(HModuleUPCTV,'upcTVAbout');
    @upcTVRead:=GetProcAddress(HModuleUPCTV,'upcTVRead');
    @upcTVReadFile:=GetProcAddress(HModuleUPCTV,'upcTVReadFile');
    @upcTVStop:=GetProcAddress(HModuleUPCTV,'upcTVStop');
    @upcTVPause:=GetProcAddress(HModuleUPCTV,'upcTVPause');
    @upcTVResume:=GetProcAddress(HModuleUPCTV,'upcTVResume');
    @upcTVSetLanguage:=GetProcAddress(HModuleUPCTV,'upcTVSetLanguage');
    @upcTVSetSpeed:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeed');
    @upcTVSetSpeaker:=GetProcAddress(HModuleUPCTV,'upcTVSetSpeaker');
    @upcTVStatus:=GetProcAddress(HModuleUPCTV,'upcTVStatus');
    //Val(FormPrincipal.EditVelocitat.text,i,e);
    i:=upcTVVelocitat;
    if (i<=0) or (i>255) then begin
      //FormPrincipal.EditVelocitat.text := '100';
      upcTVSetSpeed(100);
    end else upcTVSetSpeed(i);
  end else begin
    RecarregarLlibreriaUPCTV:=0;
    {
    MessageBox(Application.Handle,'No trobo la upctv.dll. No puc llegir els textos. Instal.leu correctament la upctv.dll','Fressa 2001 - Lectura de textos',mb_IconInformation+mb_Ok);
    FormPrincipal.ButtonLectura.Enabled:=false;
    FormPrincipal.PopupLlenguatge.Enabled:=false;
    FormPrincipal.PopupVeuDe.Enabled:=false;
    }
  end;
end;

{**********************************************************************}
Procedure CatalaHomeUPCTV;
begin
  upcTVCatala:=true;
  upcTVHome:=true;
  if HModuleUPCTV>31 then begin
    if upcTVStatus(0)<>0 then upcTVStop;
    RecarregarLlibreriaUPCTV;
    upcTVSetLanguage(99);
    upcTVSetSpeaker(0);
  end;
end;

Procedure CatalaDonaUPCTV;
begin
  upcTVCatala:=true;
  upcTVHome:=false;
  if HModuleUPCTV>31 then begin
    if upcTVStatus(0)<>0 then upcTVStop;
    RecarregarLlibreriaUPCTV;
    upcTVSetLanguage(99);
    upcTVSetSpeaker(2);
  end;
end;

Procedure CastellaHomeUPCTV;
begin
  upcTVCatala:=false;
  upcTVHome:=true;
  if HModuleUPCTV>31 then begin
    if upcTVStatus(0)<>0 then upcTVStop;
    RecarregarLlibreriaUPCTV;
    upcTVSetLanguage(101);
    upcTVSetSpeaker(1);
  end;
end;

Procedure CastellaDonaUPCTV;
begin
  upcTVCatala:=false;
  upcTVHome:=false;
  if HModuleUPCTV>31 then begin
    if upcTVStatus(0)<>0 then upcTVStop;
    RecarregarLlibreriaUPCTV;
    upcTVSetLanguage(101);
    upcTVSetSpeaker(0);
  end;
end;

{**********************************************************************}
Procedure CatalaUPCTV;
begin
  if upcTVCatala then exit;
  upcTVCatala:=true;
  if HModuleUPCTV>31 then begin
    RecarregarLlibreriaUPCTV;
    if upcTVHome then begin
      upcTVSetLanguage(99);
      upcTVSetSpeaker(0);
    end else begin
      upcTVSetLanguage(99);
      upcTVSetSpeaker(2);
    end;
  end;
end;

Procedure CastellaUPCTV;
begin
  if not upcTVCatala then exit;
  upcTVCatala:=false;
  if HModuleUPCTV>31 then begin
    if upcTVStatus(0)<>0 then upcTVStop;
    RecarregarLlibreriaUPCTV;
    if upcTVHome then begin
      upcTVSetLanguage(101);
      upcTVSetSpeaker(1);
    end else begin
      upcTVSetLanguage(101);
      upcTVSetSpeaker(0);
    end;
  end;
end;

Procedure HomeUPCTV;
begin
  if upcTVHome then exit;
  upcTVHome:=true;
  if HModuleUPCTV>31 then begin
    RecarregarLlibreriaUPCTV;
    if upcTVCatala then begin
      upcTVSetLanguage(99);
      upcTVSetSpeaker(0);
    end else begin
      upcTVSetLanguage(101);
      upcTVSetSpeaker(1);
    end;
  end;
end;

Procedure DonaUPCTV;
begin
  if not upcTVHome then exit;
  upcTVHome:=false;
  if HModuleUPCTV>31 then begin
    RecarregarLlibreriaUPCTV;
    if upcTVCatala then begin
      upcTVSetLanguage(99);
      upcTVSetSpeaker(2);
    end else begin
      upcTVSetLanguage(101);
      upcTVSetSpeaker(0);
    end;
  end;
end;

Procedure CanviarVelocitatUPCTV(i:integer);
begin
  if HModuleUPCTV>31 then begin
    if upcTVStatus(0)<>0 then upcTVStop;
    if (i<=0) or (i>255) then begin
      upcTVSetSpeed(100);
      upcTVVelocitat:=100;
    end else begin
      upcTVSetSpeed(i);
      upcTVVelocitat:=i;
    end;
  end;
end;

{**********************************************************************}
begin
  upcTVVelocitat:=100;
  upcTVHome:=true;
  upcTVCatala:=true;
end.
